#define __AVR_ATtiny13__

#include <avr/io.h>
#include <avr/interrupt.h>
#include <delay.h>

#define GREEN  PORTB0      // "  "
#define RED  PORTB2        // "  "
#define DOWN (PINB)&(1<<PINB4)           // ""
#define UP   (PINB)&(1<<PINB3)           // ""
#define keymask ~(1<<PINB4)|(1<<PINB3)
#define OSC 9600000             // 
#define TOP 0x4//(OSC/1024)/50       // 

volatile unsigned char  flag = 0;
#define KeyEXE  0x00    //  
#define KeyNew  0b01    //  

#define SBIT(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define CBIT(ADDRESS,BIT)  ((ADDRESS) &= ~(1<<(BIT)))

volatile unsigned char a=0x02;     // 

ISR (TIM0_OVF_vect)// void timer0_ovf_isr(void)
{
// Place your code here
    SBIT(flag,KeyEXE);   //  
}

void    keypress(void)
{
        if  ((~UP)&&(a<TOP)) a++;
        if  ((~DOWN)&&(a>0x00)) a--;
        if  (a==0)   
                {
                    CBIT(PORTB,GREEN);
                    SBIT(PORTB,RED);
                }
        if  (a==TOP)
                {
                    CBIT(PORTB,RED);
                    SBIT(PORTB,GREEN);
                }
        if  ((a>0)&&(a<TOP))
                {
                    SBIT(PORTB,GREEN);
                    SBIT(PORTB,RED);
                }
        OCR0B=a;
        CBIT(flag,KeyEXE);   //  
}

int main(void)
{
PORTB=0x3D;               //       xx111101  B
DDRB=0x07;                //           xx000111  B

// Timer/Counter 0 initialization
TCCR0A=0x23;                //  0x33
TCCR0B=0x0D;                //CTC Top - OCR0A
TCNT0=0x00;
OCR0A=TOP;                  //187
OCR0B=a;                    //0xBB;
TIMSK0=(1<<TOIE0);//0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;
// Global enable interrupts
//KeyEXE=0;
asm ("sei");
while (1)
      {
        if  ((flag)&(1<<KeyEXE))
        {
            keypress();
            _delay_ms(20);
        }
      }
//    return (0);
}
